import org.basex.api.client.ClientQuery;
import org.basex.api.client.ClientSession;
import org.basex.core.Context;
import org.basex.core.cmd.XQuery;
import org.basex.query.QueryProcessor;

public class BindVariable {
  public static void main(String[] args) throws Exception {
    Context ctx = new Context();
    String query = "declare variable $xml external; $xml";
    String key = "xml";
    String value = "<xml/>";
    String type = "element()";

    // create and run XQUERY command
    XQuery cmd = new XQuery(query);
    cmd.bind(key, value, type);
    System.out.println(cmd.execute(ctx));

    // create query processor instance (more low-level)
    QueryProcessor qp = new QueryProcessor(query, ctx);
    qp.bind(key, value, type);
    System.out.println(qp.value());

    // run query in client/server architecture (requires running BaseX server)
    ClientSession cs = new ClientSession("localhost", 1984, "user", "pw");
    ClientQuery cq = cs.query(query);
    cq.bind(key, value, type);
    System.out.println(cq.execute());
  }
}
